### BT+MCU 做遥控品类

如果 BT+MCU 做遥控类产品，如果不需要控制涂鸦公版灯，只需要关注 B2 命令 DP 数据互传即可；

如果需要控制涂鸦公版灯，需要参考下面的所有遥控器会用到的指令，分别在 MCU 端做合成发送：


```
2
# 遥控器按 OFF 按钮，发送标准 SIG MODEL: onoff model，MCU 通过 BC 指令传输给 BT (只取cmd_params的第一字节，0 为 OFF)
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 BC 00 08 FF FF 03 82 00 02 00 00 48 
[dbg]app_uart_run                  :94 RECEIVE RAW DATA:             55 AA 00 BC 00 01 00 BC 
[dbg]auc_mesh_sig_model_send       :112 SIG MODEL SEND

2
# 遥控器按 ON 按钮，发送标准 SIG MODEL: onoff model，MCU 通过 BC 指令传输给 BT (只取cmd_params的第一字节，1 为 ON)
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 BC 00 08 FF FF 03 82 00 02 01 00 49 
[dbg]app_uart_run                  :94 RECEIVE RAW DATA:             55 AA 00 BC 00 01 00 BC 
[dbg]auc_mesh_sig_model_send       :112 SIG MODEL SEND

3
# 遥控器按（亮度+/-）按钮，发送标准 VENDOR MODEL: 亮度调节，MCU 通过 0xBE 命令透传给 BT：(cmd_params的 2 字节，0x1000/0xFFFF 表示亮度百分比，大端)
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 BE 00 08 FF FF 00 04 83 02 10 00 5C 
[dbg]app_uart_run                  :94 RECEIVE RAW DATA:             55 AA 00 BE 00 01 00 BE 
[dbg]auc_mesh_vendor_model_send    :127 VENDOR MODEL SEND

3
# 遥控器按（亮度+/-）按钮，发送标准 VENDOR MODEL: 亮度调节，MCU 通过 0xBE 命令透传给 BT：(cmd_params的 2 字节，0x2000/0xFFFF 表示亮度百分比，大端)
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 BE 00 08 FF FF 00 04 83 02 20 00 6C 
[dbg]app_uart_run                  :94 RECEIVE RAW DATA:             55 AA 00 BE 00 01 00 BE 
[dbg]auc_mesh_vendor_model_send    :127 VENDOR MODEL SEND

3
# 遥控器按（亮度+/-）按钮，发送标准 VENDOR MODEL: 亮度调节，MCU 通过 0xBE 命令透传给 BT：(cmd_params的 2 字节，0x3000/0xFFFF 表示亮度百分比，大端)
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 BE 00 08 FF FF 00 04 83 02 30 00 7C 
[dbg]app_uart_run                  :94 RECEIVE RAW DATA:             55 AA 00 BE 00 01 00 BE 
[dbg]auc_mesh_vendor_model_send    :127 VENDOR MODEL SEND

4
# 遥控器按（色温-）按钮，发送标准 SIG MODEL: 色温调节，MCU 通过 0xBC 命令透传给 BT：(只取cmd_params的前 4 字节，0x0000000A 表示色温值，小端）
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 BC 00 0B FF FF 65 82 00 05 F0 0A 00 00 00 AA 
[dbg]app_uart_run                  :94 RECEIVE RAW DATA:             55 AA 00 BC 00 01 00 BC 
[dbg]auc_mesh_sig_model_send       :112 SIG MODEL SEND

4
# 遥控器按（色温-）按钮，发送标准 SIG MODEL: 色温调节，MCU 通过 0xBC 命令透传给 BT：(只取cmd_params的前 4 字节，0x00000012 表示色温值，小端）
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 BC 00 0B FF FF 65 82 00 05 C0 12 00 00 00 82 
[dbg]app_uart_run                  :94 RECEIVE RAW DATA:             55 AA 00 BC 00 01 00 BC 
[dbg]auc_mesh_sig_model_send       :112 SIG MODEL SEND

4
# 遥控器按（色温-）按钮，发送标准 SIG MODEL: 色温调节，MCU 通过 0xBC 命令透传给 BT：(只取cmd_params的前 4 字节，0x0000001A 表示色温值，小端）
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 BC 00 0B FF FF 65 82 00 05 90 1A 00 00 00 5A 
[dbg]app_uart_run                  :94 RECEIVE RAW DATA:             55 AA 00 BC 00 01 00 BC 
[dbg]auc_mesh_sig_model_send       :112 SIG MODEL SEND

4
# 遥控器按（色温-）按钮，发送标准 SIG MODEL: 色温调节，MCU 通过 0xBC 命令透传给 BT：(只取cmd_params的前 4 字节，0x00000022 表示色温值，小端）
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 BC 00 0B FF FF 65 82 00 05 60 22 00 00 00 32 
[dbg]app_uart_run                  :94 RECEIVE RAW DATA:             55 AA 00 BC 00 01 00 BC 
[dbg]auc_mesh_sig_model_send       :112 SIG MODEL SEND

5
# 遥控器按4个情景按钮中的一个（情景 ID=0x0000,0x1000,0x2000,0x4000），MCU 通过 B2 命令透传给 BT：(2 字节，为情景 ID, 大端）
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 B2 00 08 FF FF 06 00 00 02 00 00 BF 
5
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 B2 00 08 FF FF 06 00 00 02 10 00 CF 
5
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 B2 00 08 FF FF 06 00 00 02 20 00 DF 
5
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 B2 00 08 FF FF 06 00 00 02 40 00 FF 

6
# 遥控器按（颜色调节）按钮，发送标准 SIG MODEL: HSL 调节，MCU 通过 0xBC 命令透传给 BT：(只取cmd_params的前 6 字节，0x00000022 表示色温值，小端）
[dbg]hal_uart_send                 :112 SEND RAW DATAS:              55 AA 00 BC 00 0D FF FF 77 82 00 07 00 64 00 00 00 32 00 5C 
[dbg]app_uart_run                  :94 RECEIVE RAW DATA:             55 AA 00 BC 00 01 00 BC 
[dbg]auc_mesh_sig_model_send       :112 SIG MODEL SEND
```


代码示例：
```
case '1':{//key1-倒计时
        u8 param[10] = {0xff,0xff,0x07,0x02,0x00,0x04,0x00,0x00,0x03,0x84};//MESH互传，目的地址0xFFFF，dp=7，倒计时0x0384S
        auc_mcu_to_mesh(AUC_CMD_MESH_SEND,param,10);
    }
    break;
case '2':{//key2-ON/OFF, sig model 透传，onoff model, 目的地址0xFFFF
        static u8 onoff = 0;
        u8 param[8] = {0xff,0xff,0x03,0x82,0x00,0x02,0x01,0x00};
        param[6] = on_off;
        on_off = !on_off;
        auc_mcu_to_mesh(AUC_CMD_MESH_SIG_MODEL_SEND,param,8);           
    }
    break;
case '3':{//key3-亮度+/- 循环
        static u16 lum = 0x1000;
        u8 param[8] =  {0xff,0xff,0x00,0x04,0x83,0x02,0x10,0x10};  
        param[6] = lum >> 8;
        param[7] = lum & 0xFF;
        lum+=0x1000;
        auc_mcu_to_mesh(AUC_CMD_MESH_VENDOR_SEND,param,8);           
    }
    break;
case '4':{//key4-色温+/- 循环
        static u16 wc = 800;
        u8 param[11] = {0xff,0xff,0x65,0x82,0x00,0x05,0x00,0x00,0x00,0x00,0x00};
        param[6] = wc & 0xFF;
        param[7] = (wc >> 8) & 0xFF;
        param[8] = (wc >> 16) & 0xFF;
        param[9] = (wc >> 24) & 0xFF;
        wc += 2000;
        if(wc > 20000)wc = 800;
        auc_mcu_to_mesh(AUC_CMD_MESH_SIG_MODEL_SEND,param,11);           
    }
    break;
case '5':{//key5-情景
        u16 sence_id[4] = {0x0000,0x1000,0x2000,0x4000};
        static u8 sence_index = 0;
        u8 param[8] = {0xff,0xff,0x06,0x00,0x00,0x02,0x00,0x00};//MESH互传，目的地址0xFFFF，dp=6，4个情景轮转
        param[6] = sence_id[sence_index] >> 8;
        param[7] = sence_id[sence_index] & 0xFF;
        sence_index++;
        if(sence_index >= 4)sence_index = 0;
        auc_mcu_to_mesh(AUC_CMD_MESH_SEND,param,8);
    }
    break;
case '6':{//key6-颜色
        static u16 wc = 800;
        u8 param[13] = {0xff,0xff,0x77,0x82,0x00,0x07,0x00,0x00,0x00,0x00,0x00};
        param[6] = wc & 0xFF;
        param[7] = (wc >> 8) & 0xFF;
        param[8] = (wc >> 16) & 0xFF;
        param[9] = (wc >> 24) & 0xFF;
        wc += 2000;
        if(wc > 20000)wc = 800;
        auc_mcu_to_mesh(AUC_CMD_MESH_SIG_MODEL_SEND,param,11);           
    }
    break;
```

下图是涂鸦照明所用到的 MODEL：

DP ID | DP 功能 | Model | Message Name | Opcode | 备注
---|---|---|---|---
1 | 开关 | OnOff Model | Generic OnOff Get </br> Generic OnOff Set </br> Generic OnOff Set Unack  </br> Generic OnOff Status | 0x82 0x01 </br>   0x82 0x02 </br>  0x82 0x03 </br>  0x82 0x04 | 1~5路公用
2 | 模式 | Vendor Model | | | 用于白光彩光模式切换
3 | 亮度 | CTL Model Lightness | Light Lightness Get </br> Light Lightness Set </br> Light Lightness Set Unack </br> Light Lightness Status  </br> Light CTL Get </br> Light CTL Set  </br> Light CTL Set Unacknowledged </br> Light CTL Set Unacknowledged </br> | 0x82 0x4B <br> 0x82 0x4C </br> 0x82 0x4D </br> 0x82 0x4E </br> 0x82 0x5D </br> 0x82 0x5E </br> 0x82 0x5F </br> 0x82 0x60 | 
4 | 色温 | CTL Model temperature | Light CTL Temperature Get </br> Light CTL Temperature Set </br> Light CTL Temperature Set Unack </br> Light CTL Temperature Status <br> | 0x82 0x61 </br> 0x82 0x64 </br> 0x82 0x65 </br> 0x82 0x66 | SIG MESH数据默认范围： 800~20000
5 | 颜色 | HSL Model | Light HSL Get </br> Light HSL Set </br> Light HSL Set Unack </br> Light HSL Status </br>  | 0x82 0x6D </br> 0x82 0x76 </br> 0x82 0x77 </br> 0x82 0x78 | 2 字节 lightness; 2 字节 hue; 2 字节 sat；小端，实际L\H\S的值为：</br> H (degrees) = 360⁰ * (Light HSL H) / 65536; </br> S = (Light HSL S) / 65535; </br> L = (Light HSL L)/65535

</br>

注：发送颜色命令的实际参数构成举例：

```
在线 RGB 转 HSL 工具：http://tools.jb51.net/color/rgb_hex_hsl/
发送红色举例：

rgb(255, 0, 0)
hsl(0°, 100.0%, 50.0%) -> HSL_SEND_VALUE(0,0xFFFF,0x7FFF)

2 L		7F FF (小端 FF 7F）
2 H		00 00
2 S		FF FF

55 AA 00 BC 00 0D FF FF 77 82 00 07 FF 7F 00 00 FF FF 00 42


发送绿色举例：

rgb(0, 255, 0)
hsl(120°, 100.0%, 50.0%) -> HSL_SEND_VALUE(0x5555,0xFFFF,0x7FFF)

2 L		7F FF (小端 FF 7F）
2 H		55 55
2 S		FF FF

55 AA 00 BC 00 0D FF FF 77 82 00 07 FF 7F 55 55 FF FF 00 EC 
```


</br>


